Name:           hbase
Version:        0.19.3
Release:        %mkrel 1
License:        Apache License
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Group:          Databases
Summary:        Apache Hbase server and client
BuildArch:	noarch
Distribution:	XtreemOS
Packager:	Niek Linnenbank <nieklinnenbank@gmail.com>
URL:		http://hadoop.apache.org/hbase/
Source:         %{name}-%{version}/%{name}-%{version}.tar.gz
Patch:		hbase-0.19.1_environ.patch
BuildRequires:	java >= 1.6.0 java-devel >= 1.6.0
Requires:       java >= 1.6.0 log4j jetty5 junit >= 3.8 lucene openssh-server
Requires:       tomcat5-servlet-2.4-api tomcat5-jasper tomcat5-jsp-2.0-api
Requires:	jakarta-commons-httpclient >= 3.0 jakarta-commons-logging >= 1.0
Requires:	jakarta-commons-cli jakarta-commons-el

%description
HBase is the Hadoop database. Its an open-source, distributed, column-oriented
store modeled after the Google paper, Bigtable: A Distributed Storage System
for Structured Data by Chang et al. Just as Bigtable leverages the distributed
data storage provided by the Google File System, HBase provides Bigtable-like
capabilities on top of Hadoop.

%prep
%setup -q
%patch -p1
%build
ant package

%install
%{__rm} -Rf %{buildroot}
# Set variables.
CONFDIR=$RPM_BUILD_ROOT%{_sysconfdir}/%{name}
ENVDIR=$RPM_BUILD_ROOT/etc/profile.d
HOMEDIR=$RPM_BUILD_ROOT%{_datadir}/%{name}
LIBDIR=$HOMEDIR/lib
JAVADIR=$RPM_BUILD_ROOT%{_datadir}/java
WEBDIR=$RPM_BUILD_ROOT%{_datadir}/%{name}/webapps
DOCDIR=$RPM_BUILD_ROOT%{_datadir}/%{name}/docs
MANDIR=$RPM_BUILD_ROOT%{_mandir}
BINDIR=$RPM_BUILD_ROOT%{_bindir}

# Copy Hbase jars.
mkdir -p $JAVADIR
cp build/hbase-%{version}*.jar $JAVADIR

# Currently, these don't have (adequate) RPM's yet.
mkdir -p $LIBDIR
cp lib/zookeeper*.jar $LIBDIR
cp lib/hadoop*.jar $LIBDIR
cp lib/commons-math*.jar $LIBDIR
cp lib/jruby*.jar $LIBDIR
cp lib/xmlenc*.jar $LIBDIR
cp lib/libthrift*.jar $LIBDIR

# Copy binaries and scripts.
mkdir -p $BINDIR
cp bin/* $BINDIR

# Copy web applications
mkdir -p $WEBDIR
cp -R webapps $WEBDIR

# Copy configuration files.
mkdir -p $CONFDIR
cp conf/* $CONFDIR

# Create hbase home directory
mkdir -p $HOMEDIR
ln -s %{_sysconfdir}/%{name} $HOMEDIR/conf
ln -s %{_bindir} $HOMEDIR/bin

# Load these jars in Hbase
mkdir -p $LIBDIR
ln -s %{_datadir}/java/hbase-%{version}.jar $LIBDIR/hbase-%{version}.jar
ln -s %{_datadir}/java/hbase-%{version}-test.jar $LIBDIR/hbase-%{version}-test.jar
ln -s %{_datadir}/java/commons-cli.jar $LIBDIR/commons-cli.jar
ln -s %{_datadir}/java/commons-httpclient.jar $LIBDIR/commons-httpclient.jar
ln -s %{_datadir}/java/commons-logging.jar $LIBDIR/commons-logging.jar
ln -s %{_datadir}/java/commons-logging-api.jar $LIBDIR/commons-logging-api.jar
ln -s %{_datadir}/java/commons-el.jar $LIBDIR/commons-el.jar
ln -s %{_datadir}/java/jasper5-compiler.jar $LIBDIR/jasper-compiler.jar
ln -s %{_datadir}/java/jasper5-runtime.jar $LIBDIR/jasper-runtime.jar
ln -s %{_datadir}/java/jspapi.jar $LIBDIR/jspapi.jar
ln -s %{_datadir}/java/jetty5/jetty5.jar $LIBDIR/jetty5.jar
ln -s %{_datadir}/java/junit.jar $LIBDIR/junit.jar
ln -s %{_datadir}/java/log4j.jar $LIBDIR/log4j.jar
ln -s %{_datadir}/java/lucene.jar $LIBDIR/lucene.jar
ln -s %{_datadir}/java/servletapi5.jar $LIBDIR/servlet-api.jar

# Copy documentation
mkdir -p $DOCDIR
mkdir -p $MANDIR/man1
cp *.txt $DOCDIR

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc LICENSE.txt NOTICE.txt README.txt CHANGES.txt
%{_bindir}/*.sh
%{_bindir}/*.rb
%{_mandir}/*
%{_bindir}/hbase
/usr/share/java/*.jar
%{_datadir}/%{name}
%config %{_sysconfdir}/%{name}/*
